import time
import sys
import pyautogui as pag

class MousePath(object):
    """Get the path from the mouse's moving."""

    def __init__(self, TIME=0.05):
        """TIME __init__ = 0.05min"""
        self._TIME = TIME
        self._ListXY = []
        self._saveSeconds = TIME * 60
        self._parentTime = -1
        self._counter = 1
        self._ListX = []
        self._ListY = []
        self._X = -1
        self._Y = -1
        self._start = 0

    def run(self):
        """
        main Run
        return the mouse path list.
        """
        print('\n#1. Sampling procession...\n' + 'a.Time Counting...\n')
        self._start = time.time()
        while True:
            x, y = pag.position()  # 返回鼠标的坐标

            if self._X != x and self._Y != y:
                self._ListXY.append((x, y))
                self._ListX.append(x)
                self._ListY.append(y)

                self._X = x
                self._Y = y

            PARENTTIME = self._saveSeconds - (time.time() - self._start)
            if int(PARENTTIME) != int(self._parentTime):
                print('%d ' % PARENTTIME, end='')
                sys.stdout.flush()

                if self._counter == 10:
                    print('\n')
                    self._counter = 1
                else:
                    self._counter += 1

                self._parentTime = PARENTTIME

            if time.time() - self._start >= self._TIME * 60:
                break

        print('\n')
        return self._ListXY

    def egg(self):
        print('\n'.join([''.join([('Love'[(x - y) % len('Love')] if (( x * 0.05)
            ** 2 + ( y * 0.1) ** 2 - 1) ** 3 - ( x * 0.05) ** 2 * (y * 0.1) ** 3 <=
            0 else ' ')for x in range(-30, 30)]) for y in range(30, -30, -1)]))

    @classmethod
    def showClassMethodInfo(cls):
        print(cls.__name__)
        print(dir(cls))
